//
//  ViewController.swift
//  iOSAccelerometer2
//
//  Created by Michael Wilhelm on 1/05/2016.
//  Copyright © 2016 Michael Wilhelm. All rights reserved.
//

import UIKit
import CoreMotion


class ViewController: UIViewController {
    
    // uiAttribute
    @IBOutlet var tStatus: UITextView!
    
    var uiView : UIView?
    
    // Verweis auf die Geraete
    var uiDynamicAnimator: UIDynamicAnimator? = nil
    var uiGravityBehavior = UIGravityBehavior()        // neu
    let uiCollisionBehavior = UICollisionBehavior()    // neu
    let cmMotionManager = CMMotionManager()
    let nsOperationQueue = NSOperationQueue()
    

    
    override func viewDidAppear(animated: Bool) {
        cmMotionManager.startDeviceMotionUpdatesToQueue(nsOperationQueue, withHandler: cmAccelerometerHandler)
    }
    
    func cmAccelerometerHandler(motion: CMDeviceMotion?, error: NSError?) {
        if error != nil {
            tStatus.text = "Error"
        }
        else {
            let gravity : CMAcceleration = motion!.gravity
            let x = CGFloat(gravity.x)
            let y = CGFloat(gravity.y)
            let z = CGFloat(gravity.z)
            tStatus.text = "x: " + String(x) + "\n" +
                "y: " + String(y) + "\n" +
                "z: " + String(z)
            let cgPoint = CGPointMake(x, y)
            let v = CGVectorMake(cgPoint.x, cgPoint.y)
            uiGravityBehavior.gravityDirection = v
        }
    }
    
    override func viewWillDisappear(animated: Bool) {
        cmMotionManager.stopAccelerometerUpdates()
    }
    
    func initSensors() {
        uiDynamicAnimator = UIDynamicAnimator(referenceView: self.view)
        uiGravityBehavior.addItem(uiView!)
        uiGravityBehavior.gravityDirection = CGVectorMake(0, 0.8)
        uiDynamicAnimator?.addBehavior(uiGravityBehavior)
        uiCollisionBehavior.addItem(uiView!)
        uiCollisionBehavior.translatesReferenceBoundsIntoBoundary = true
        uiDynamicAnimator?.addBehavior(uiCollisionBehavior)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.view.backgroundColor = UIColor.greenColor()
        addView( CGRectMake(150, 150, 50, 50) )
        initSensors()
    }
    
    func addView(location: CGRect) {
        let newView = UIView(frame: location)
        newView.backgroundColor = UIColor.blackColor()
        view.insertSubview(newView, atIndex: 0)
        uiView = newView
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
}

